'use strict';

app.controller('eventController',
    ['$scope', '$rootScope', '$log', '$location', 'genericServiceInvoker', 'sharedDataService', 'eventService',
        function ($scope, $rootScope, $log, $location, $genericServiceInvoker, $sharedDataService, $eventService) {

            $log.debug("eventController");
            $rootScope.bg = '';

            $scope.openModal = function (size) {
                var modalInstance = $uibModal.open({
                    animation: $scope.animationsEnabled,
                    templateUrl: 'view/openNetworking.html',
                    controller: 'openNetworkController',
                    size: size
                });
            };

            $eventService.getEvents(function (success, result) {
                if (success) {
                    $scope.eventList = result;
                } else {
                    $scope.errorModal = true;
                    $scope.error = "Sorry there has been an issue retrieving the application information, please try again later.";
                }
            });

            $scope.closeModalDialog = function () {
                $scope.errorModal = !$scope.errorModal;
            };

            $scope.openEvent = function (eventId) {

                if ($sharedDataService.getUser().mobile == null) {
                    $rootScope.globals.eventDetailId = 1;
                    $rootScope.globals.applicationDetailId = 1;
                    $location.path('/profile');

                    $scope.openModal('sm');
                }

                $eventService.getEvent(eventId, $sharedDataService.getAttendeeId(), function (success, result) {
                    if (success) {
                        $rootScope.globals.eventDetailId = result.event.eventId;
                        $rootScope.globals.applicationDetailId = result.event.applicationId;
                        $rootScope.eventDetail = result;
                        $sharedDataService.setEventDetail(result);
                        $location.path("/eventDetail");
                    } else {
                        $scope.errorModal = true;
                        $scope.error = "Sorry there has been an issue retrieving the event information, please try again later.";
                    }
                });
            };

            $scope.scan = function () {
                barcodeScanner.scan().then(function (result) {
                    if (result.canceled) {
                        return;
                    }
                    // text from qr code or barcode is contained in result.text
                }, function (err) {
                    alert(err);
                });
            };

        }]);