'use strict';

app.controller('profileController',
    ['$scope', '$rootScope', '$log', '$location', 'PROPERTIES', 'sharedDataService', 'attendeeService',
        function ($scope, $rootScope, $log, $location, PROPERTIES, $sharedDataService, attendeeService) {

            $log.debug("profileController");
            $scope.profile = $sharedDataService.getUser();
            $scope.qrCode = $scope.profile.attendeeId;
            $scope.tcURL = PROPERTIES.termsURL;
            $scope.privacyURL = PROPERTIES.privacyURL;
            $scope.showHide = false;

            $rootScope.bg = '';

            $log.debug($scope.profile);

            $scope.updateDetails = function () {
                attendeeService.save($scope.profile, function (success, response) {
                    $log.debug(response);
                    if (success) {
                        $scope.showHide = false;
                        $scope.errorModal = true;
                        $scope.error = "Your profile has been updated.";
                        $sharedDataService.setUser(response);

                    } else {
                        $scope.showHide = false;
                        $scope.errorModal = true;
                        $scope.error = "Sorry there has been an issue updating your profile, please try again later.";
                    }
                });
                $scope.showHide = true;
            };

            $scope.closeModalDialog = function () {
                $scope.errorModal = !$scope.errorModal;
                $location.path("/");
            };

        }]);