'use strict';

app.controller('questionController',
    ['$scope', '$rootScope', '$log', '$location', 'sharedDataService', 'questionService',
        function ($scope, $rootScope, $log, $location, $sharedDataService, $questionService) {

            $log.debug("questionController");

            $scope.askQuestion = function () {

                var question = {
                    attendeeId: $sharedDataService.getAttendeeId(),
                    question: $scope.question
                }

                $questionService.askQuestion($sharedDataService.getEventDetailId(), question, function (success, response) {
                    $log.debug(response);
                    if (success) {
                        $scope.showHide = false;
                        $scope.errorModal = true;
                        $scope.error = "Your question has been sent.";
                    } else {
                        $scope.showHide = false;
                        $scope.errorModal = true;
                        $scope.error = "Sorry there has been an issue adding your question, please try again later.";
                    }
                });
                $scope.showHide = true;
            };

            $scope.closeModalDialog = function () {
                $scope.errorModal = !$scope.errorModal;
                $location.path('/eventDetail');
            };

        }]);