'use strict';

app.controller('registerController',
    ['$scope', '$rootScope', '$log', '$location', 'PROPERTIES', 'sharedDataService', 'attendeeService',
        function ($scope, $rootScope, $log, $location, PROPERTIES, $sharedDataService, $attendeeService) {

            $scope.showHide = false;
            $scope.applicationName = PROPERTIES.applicationName;
            $scope.tcURL = PROPERTIES.termsURL;
            $scope.privacyURL = PROPERTIES.privacyURL;
            $log.debug($scope.showHide);

            $log.debug("registerController");

            $scope.registerRequest = {applicationId: PROPERTIES.applicationId, attendee: {}};

            $scope.register = function () {
                $scope.showHide = true;
                $log.debug($scope.showHide);
                $attendeeService.register($scope.registerRequest, function (success, response) {
                    $log.debug(response);
                    if (success) {
                        $scope.showHide = false;
                        $log.debug($scope.showHide);
                        $location.path('registerSuccess');
                    } else {
                        $scope.showHide = false;
                        $scope.errorModal = true;
                        $log.debug($scope.showHide);
                        // alert(response);
                        if (response != null) {
                            $scope.error = response.message;
                        } else {
                            $scope.error = "Sorry there has been an issue registering your profile, please try again later.";
                        }
                    }
                });
            };

            jQuery('input').blur();
            jQuery('select').blur();
        }]);