app.service('genericServiceInvoker', ['$http', '$log', 'PROPERTIES',
    function ($http, $log, PROPERTIES) {

        this.invokeWithObject = function (serviceName, objectRequest, callbackHandler) {

            var request = $http.post(PROPERTIES.baseURL + serviceName, objectRequest);

            $log.debug(objectRequest);

            request.success(function (data, status, headers, config) {
                $log.debug("Valid Response");
                $log.debug(data);
                callbackHandler(true, data);
            });

            request.error(function (data, status, headers, config) {
                $log.debug("Invalid Response");
                $log.debug(data);
                callbackHandler(false, data);
            });
        };

        this.invoke = function (serviceName, callbackHandler) {

            var request = $http.post(PROPERTIES.baseURL + serviceName);

            $log.debug(serviceName);

            request.success(function (data, status, headers, config) {
                $log.debug("Valid Response");
                $log.debug(data);
                callbackHandler(true, data);
            });

            request.error(function (data, status, headers, config) {
                $log.debug("Invalid Response");
                $log.debug(data);
                callbackHandler(false, data);
            });
        };
    }]);