'use strict';

app.factory('checkinService',
    ['$http', '$rootScope', '$log', 'PROPERTIES', 'sharedDataService', 'genericServiceInvoker', '$cordovaGeolocation',
        function ($http, $rootScope, $log, PROPERTIES, sharedDataService, $genericServiceInvoker, $cordovaGeolocation) {

            var service = {};

            service.checkin = function (sessionId, callback) {

                var posOptions = {timeout: 10000, enableHighAccuracy: false};
                $cordovaGeolocation
                    .getCurrentPosition(posOptions)
                    .then(function (position) {

                        var checkin = {
                            sessionId: sessionId,
                            attendeeId: sharedDataService.getAttendeeId(),
                            checkinDatetime: new Date(),
                            lat: position.coords.latitude,
                            lon: position.coords.longitude
                        }
                        $genericServiceInvoker.invokeWithObject("checkin/checkin", checkin, callback);

                    }, function (err) {
                        var checkin = {
                            sessionId: sessionId,
                            attendeeId: sharedDataService.getAttendeeId(),
                            checkinDatetime: new Date(),
                            lat: -1,
                            lon: -1
                        }
                        $genericServiceInvoker.invokeWithObject("checkin/checkin", checkin, callback);
                    });
            };

            service.rate = function (sessionId, rating, callback) {

                var checkin = {
                    sessionId: sessionId,
                    attendeeId: sharedDataService.getAttendeeId(),
                    rating: rating
                };
                $genericServiceInvoker.invokeWithObject("checkin/rate", checkin, callback);
            };

            service.remind = function (sessionId, callback) {
                var checkin = {
                    sessionId: sessionId,
                    attendeeId: sharedDataService.getAttendeeId(),
                    remindMe: true
                };
                $genericServiceInvoker.invokeWithObject("checkin/remind", checkin, callback);
            };

            service.remove = function (sessionId, callback) {
                var checkin = {
                    sessionId: sessionId,
                    attendeeId: sharedDataService.getAttendeeId(),
                };
                $genericServiceInvoker.invokeWithObject("checkin/remove", checkin, callback);
            };

            service.add = function (sessionId, callback) {

                var checkin = {
                    sessionId: sessionId,
                    attendeeId: sharedDataService.getAttendeeId(),
                };
                $genericServiceInvoker.invokeWithObject("checkin/add", checkin, callback);
            };

            return service;
        }]);