'use strict';

app.factory('loginService',
    ['$http', '$cookieStore', '$rootScope', '$log', 'PROPERTIES', 'sharedDataService', 'genericServiceInvoker',
        function ($http, $cookieStore, $rootScope, $log, PROPERTIES, sharedDataService, $genericServiceInvoker) {

            var service = {};

            service.Login = function (email, pin, callback) {
                $http.post(PROPERTIES.baseURL + "attendee/login", {
                    applicationId: PROPERTIES.applicationId,
                    email: email,
                    pin: pin
                }, {
                    headers: {
                        'Authorization': 'Basic',
                        'Accept': 'application/json, text/plain, */*',
                        'Content-Type': 'application/json;charset=utf-8'
                    }
                })
                    .success(function (data) {
                        $log.debug("login successful");
                        callback(true, data)

                    })
                    .error(function (data) {
                        $log.debug("login error");
                        $log.debug(data);
                        callback(false, data)
                    });

            };

            service.forgottenPin = function (email, callback) {

                var loginRequest = {applicationId: PROPERTIES.applicationId, email: email};

                $genericServiceInvoker.invokeWithObject("attendee/forgottenPin", loginRequest, callback);
            };

            service.SetCredentials = function (email, pin, response) {

                sharedDataService.setLoginResponse(response);

                var authdata = email + ':' + pin;

                $rootScope.globals = {
                    currentUser: {
                        email: response.email,
                        authdata: authdata
                    }
                };

                localStorage["authInformation"] = authdata;

                $log.debug(localStorage["authInformation"]);
                var what = localStorage["authInformation"];

                $http.defaults.headers.common['Authorization'] = 'Basic ' + authdata;

                //The cookies value only keep for 1 day
                var expireDate = new Date(new Date().getTime() + 24 * 60 * 60 * 1000);
                expireDate.setDate(expireDate.getDate() + 1);

                $cookieStore.put('globals', $rootScope.globals, {'expires': expireDate});
            };

            service.ClearCredentials = function () {
                localStorage.clear();
                $rootScope.globals = {};
                $cookieStore.remove('globals');
                $http.defaults.headers.common.Authorization = 'Basic ';
                sharedDataService.clearSession();
            };

            return service;
        }]);