/*
 a convenient way to check whether a deep object is null or not

 example:
 var test = {level1:{level2:{level3:'level3'}} };

 checkNested(test, 'level1', 'level2', 'level3'); // true
 checkNested(test, 'level1', 'level2', 'foo'); // false

 */
function checkNested(obj /*, level1, level2, ... levelN*/) {
    if (!obj || obj == null || typeof obj == 'undefined') return false;

    var args = Array.prototype.slice.call(arguments, 1);

    for (var i = 0; i < args.length; i++) {
        if (!obj || !obj.hasOwnProperty(args[i]) || (obj[args[i]] == null) || typeof obj[args[i]] == 'undefined') {
            return false;
        }
        obj = obj[args[i]];
    }
    return true;
}

function containsObject (obj, objectName, list) {

    for (var i = 0; i < list.length; i++) {
        if (list[i][objectName] == obj[objectName]) {
            return true;
        }
    }

    return false;
}

